<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| USER's PHOTO ALBUMS for PHP-Fusion 7.00
| Filename: showuserphoto.php
| Author: Sergei Gushchin (garry)
| e-mail: garry33@yandex.ru
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "maincore.php";
include LOCALE.LOCALESET."photogallery.php";

define("SAFEMODE", @ini_get("safe_mode") ? true : false);

echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">
<html>
<head>
<title>".$settings['sitename']."</title>
<meta http-equiv='Content-Type' content='text/html; charset=".$locale['charset']."'>
<meta name='description' content='".$settings['description']."'>
<meta name='keywords' content='".$settings['keywords']."'>
<link rel='stylesheet' href='".THEME."styles.css' type='text/css'>
<script type='text/javascript' src='".INCLUDES."jscript.js'></script>
</head>
<body style='margin:0px'>\n";

if (!isset($_GET['photo_id']) || !isnum($_GET['photo_id'])) {
	redirect("userphotogallery.php");
} else {
	$result = dbquery(
		"SELECT tp.*, ta.* FROM ".DB_USERPHOTOS." tp
		LEFT JOIN ".DB_USERPHOTO_ALBUMS." ta USING (album_id)
		WHERE photo_id='".$_GET['photo_id']."' GROUP BY tp.photo_id
	");
	if (dbrows($result)) {
		$data = dbarray($result);
		if (!checkgroup($data['album_access'])) {
			redirect(FUSION_SELF);
		} else {
			define("PHOTODIR", PHOTOS.(!SAFEMODE ? "useralbum_".$data['album_id']."/" : ""));
			$photo_file = PHOTODIR.$data['photo_filename'];
			echo "<a href=\"javascript:;\" onclick=\"window.close();\"><img src='$photo_file' alt='".$data['photo_filename']."' title='".$locale['458']."' border='0'></a>\n";
		}
	} else {
		echo "<script language='text/javascript'>window.close();</script>\n";
	}
}

echo "</body>\n</html>\n";
?>